# coding: utf-8

"""
    CERN Unified Storage API

    A unified storage API for all data-storage back-ends.

    OpenAPI spec version: 3.3.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from setuptools import setup, find_packages

NAME = "sapi"
VERSION = "0.1.2"
# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools

REQUIRES = [
    "requests",
    "requests_kerberos",
    "urllib3 >= 1.15",
    "six >= 1.10",
    "certifi",
    "python-dateutil",
    "fire",
    "configparser",
    "python-cern-sso-krb",
    ]

setup(
    name=NAME,
    version=VERSION,
    description="CERN Unified Storage API client",
    author='Ignacio Coterillo',
    author_email="ignacio.coterillo@cern.ch",
    url="https://github.com/icot/sapi_client",
    keywords=["Swagger", "CERN", "SAPI"],
    install_requires=REQUIRES,
    packages=find_packages(),
    scripts=["bin/sapi"],
    include_package_data=True,
    long_description="""
    Client for the CERN IT-DB Storage API
    """,
    license='GPLv3',
    classifiers=[
        # How mature is this project? Common values are
        #   3 - Alpha
        #   4 - Beta
        #   5 - Production/Stable
        'Development Status :: 4 - Beta',

        # Indicate who your project is intended for
        'Intended Audience :: Developers',

        # Pick your license as you wish (should match "license" above)
        'License :: OSI Approved :: GNU General Public License v3 (GPLv3)',

        # Specify the Python versions you support here. In particular, ensure
        # that you indicate whether you support Python 2, Python 3 or both.
        'Programming Language :: Python :: 2.7',
    ],
)
